// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function CreatePriorityQueueBTNumbers(){
  var q;

  q = {};
  q.heap = CreateDynamicArrayNumbers();

  return q;
}
function FreePriorityQueueBTNumbers(q){
  FreeDynamicArrayNumbers(q.heap);
  delete(q);
}
function PeekPriorityQueueBTNumbers(q, keyReference){
  var found;

  if( !IsEmptyPriorityQueueBTNumbers(q) ){
    keyReference.numberValue = DynamicArrayNumbersIndex(q.heap, 0);
    found = true;
  }else{
    found = false;
  }

  return found;
}
function InsertIntoPriorityQueueBTNumbers(q, key){
  DynamicArrayAddNumber(q.heap, key);

  if(SizeOfPriorityQueueBTNumbers(q) >= 2){
    SiftUpPriorityQueueBTNumbers(q, q.heap.lengthx - 1);
  }
}
function PopPriorityQueueBTNumbers(q, keyReference){
  var found;

  found = PeekPriorityQueueBTNumbers(q, keyReference);

  if(found){
    DeleteTopPriorityQueueBTNumbers(q);
  }

  return found;
}
function DeleteTopPriorityQueueBTNumbers(q){
  var found;
  var last;

  found = IsEmptyPriorityQueueBTNumbers(q);

  if( !IsEmptyPriorityQueueBTNumbers(q) ){
    last = q.heap.lengthx - 1;
    SwapElementsOfNumberArray(q.heap.array, 0, last);

    DynamicArrayRemoveNumber(q.heap, last);

    SiftDownPriorityQueueBTNumbers(q, 0);
  }

  return found;
}
function ArrayToPriorityQueueBTNumbers(keys){
  var q;
  var i;

  q = CreatePriorityQueueBTNumbers();

  for(i = 0; i < keys.length; i = i + 1){
    InsertIntoPriorityQueueBTNumbers(q, keys[i]);
  }

  return q;
}
function SizeOfPriorityQueueBTNumbers(q){
  return q.heap.lengthx;
}
function IsEmptyPriorityQueueBTNumbers(q){
  return q.heap.lengthx == 0;
}
function SiftUpPriorityQueueBTNumbers(q, index){
  var parent;
  var iKey, pKey;
  var done;

  done = false;
  for(;  !done  && index != 0; ){
    parent = Math.floor((index - 1)/2);

    iKey = DynamicArrayNumbersIndex(q.heap, index);
    pKey = DynamicArrayNumbersIndex(q.heap, parent);

    if(iKey > pKey){
      SwapElementsOfNumberArray(q.heap.array, index, parent);
    }else{
      done = true;
    }

    index = parent;
  }
}
function SiftDownPriorityQueueBTNumbers(q, index){
  var parent, c1, c2;
  var c1Key, c2Key, pKey, size;
  var done;

  size = SizeOfPriorityQueueBTNumbers(q);

  done = false;
  for(;  !done ; ){
    parent = index;
    c1 = 2*parent + 1;
    c2 = 2*parent + 2;

    if(c1 < size && c2 < size){
      pKey = DynamicArrayNumbersIndex(q.heap, parent);
      c1Key = DynamicArrayNumbersIndex(q.heap, c1);
      c2Key = DynamicArrayNumbersIndex(q.heap, c2);

      if(c1Key > pKey || c2Key > pKey){
        if(c1Key >= c2Key){
          SwapElementsOfNumberArray(q.heap.array, c1, parent);
          index = c1;
        }else if(c1Key <= c2Key){
          SwapElementsOfNumberArray(q.heap.array, c2, parent);
          index = c2;
        }else{
          done = true;
        }
      }else{
        done = true;
      }
    }else if(c1 < size){
      pKey = DynamicArrayNumbersIndex(q.heap, parent);
      c1Key = DynamicArrayNumbersIndex(q.heap, c1);

      if(c1Key > pKey){
        SwapElementsOfNumberArray(q.heap.array, c1, parent);
        index = c1;
      }else{
        done = true;
      }
    }else if(c2 < size){
      pKey = DynamicArrayNumbersIndex(q.heap, parent);
      c2Key = DynamicArrayNumbersIndex(q.heap, c2);

      if(c2Key > pKey){
        SwapElementsOfNumberArray(q.heap.array, c2, parent);
        index = c2;
      }else{
        done = true;
      }
    }else{
      done = true;
    }
  }
}
function CreatePriorityQueueBTNumKeyValue(){
  var q;

  q = {};
  q.heapKey = CreateDynamicArrayNumbers();
  q.heapValue = CreateDynamicArrayNumbers();

  return q;
}
function FreePriorityQueueBTNumKeyValue(q){
  FreeDynamicArrayNumbers(q.heapKey);
  FreeDynamicArrayNumbers(q.heapValue);
  delete(q);
}
function PeekPriorityQueueBTNumKeyValue(q, keyReference, valueReference){
  var found;

  if( !IsEmptyPriorityQueueBTNumKeyValue(q) ){
    keyReference.numberValue = DynamicArrayNumbersIndex(q.heapKey, 0);
    valueReference.numberValue = DynamicArrayNumbersIndex(q.heapValue, 0);
    found = true;
  }else{
    found = false;
  }

  return found;
}
function InsertIntoPriorityQueueBTNumKeyValue(q, key, value){
  DynamicArrayAddNumber(q.heapKey, key);
  DynamicArrayAddNumber(q.heapValue, value);

  if(SizeOfPriorityQueueBTNumKeyValue(q) >= 2){
    SiftUpPriorityQueueBTNumKeyValue(q, q.heapKey.lengthx - 1);
  }
}
function PopPriorityQueueBTNumKeyValue(q, keyReference, valueReference){
  var found;

  found = PeekPriorityQueueBTNumKeyValue(q, keyReference, valueReference);

  if(found){
    DeleteTopPriorityQueueBTNumKeyValue(q);
  }

  return found;
}
function DeleteTopPriorityQueueBTNumKeyValue(q){
  var found;
  var last;

  found = IsEmptyPriorityQueueBTNumKeyValue(q);

  if( !IsEmptyPriorityQueueBTNumKeyValue(q) ){
    last = q.heapKey.lengthx - 1;
    SwapElementsOfNumberArray(q.heapKey.array, 0, last);
    SwapElementsOfNumberArray(q.heapValue.array, 0, last);

    DynamicArrayRemoveNumber(q.heapKey, last);
    DynamicArrayRemoveNumber(q.heapValue, last);

    SiftDownPriorityQueueBTNumKeyValue(q, 0);
  }

  return found;
}
function ArrayToPriorityQueueBTNumKeyValue(keys, values){
  var q;
  var i;

  q = CreatePriorityQueueBTNumKeyValue();

  for(i = 0; i < keys.length; i = i + 1){
    InsertIntoPriorityQueueBTNumKeyValue(q, keys[i], values[i]);
  }

  return q;
}
function SizeOfPriorityQueueBTNumKeyValue(q){
  return q.heapKey.lengthx;
}
function IsEmptyPriorityQueueBTNumKeyValue(q){
  return q.heapKey.lengthx == 0;
}
function SiftUpPriorityQueueBTNumKeyValue(q, index){
  var parent;
  var iKey, pKey;
  var done;

  done = false;
  for(;  !done  && index != 0; ){
    parent = Math.floor((index - 1)/2);

    iKey = DynamicArrayNumbersIndex(q.heapKey, index);
    pKey = DynamicArrayNumbersIndex(q.heapKey, parent);

    if(iKey > pKey){
      SwapElementsOfNumberArray(q.heapKey.array, index, parent);
      SwapElementsOfNumberArray(q.heapValue.array, index, parent);
    }else{
      done = true;
    }

    index = parent;
  }
}
function SiftDownPriorityQueueBTNumKeyValue(q, index){
  var parent, c1, c2;
  var c1Key, c2Key, pKey, size;
  var done;

  size = SizeOfPriorityQueueBTNumKeyValue(q);

  c1Key = 0;
  c2Key = 0;
  done = false;
  for(;  !done ; ){
    parent = index;
    c1 = 2*parent + 1;
    c2 = 2*parent + 2;

    pKey = DynamicArrayNumbersIndex(q.heapKey, parent);
    if(c1 < size){
      c1Key = DynamicArrayNumbersIndex(q.heapKey, c1);
    }
    if(c2 < size){
      c2Key = DynamicArrayNumbersIndex(q.heapKey, c2);
    }

    if(c1Key > pKey && c1 < size || c2Key > pKey && c2 < size){
      if(c1Key >= c2Key && c1 < size){
        SwapElementsOfNumberArray(q.heapKey.array, c1, parent);
        SwapElementsOfNumberArray(q.heapValue.array, c1, parent);
        index = c1;
      }else if(c1Key <= c2Key && c2 < size){
        SwapElementsOfNumberArray(q.heapKey.array, c2, parent);
        SwapElementsOfNumberArray(q.heapValue.array, c2, parent);
        index = c2;
      }else{
        done = true;
      }
    }else{
      done = true;
    }
  }
}
function test(){
  var failures;

  failures = CreateNumberReference(0);

  testPriorityQueueBTNumbersKeyValue(failures);
  testPriorityQueueBTNumbers(failures);
  testPriorityQueueBTNumbers2(failures);

  return failures.numberValue;
}
function testPriorityQueueBTNumbersKeyValue(failures){
  var q;
  var size;
  var keyReference, valueReference;
  var found;

  keyReference = {};
  valueReference = {};

  q = CreatePriorityQueueBTNumKeyValue();

  InsertIntoPriorityQueueBTNumKeyValue(q, 5, 1);
  InsertIntoPriorityQueueBTNumKeyValue(q, 11, 2);
  InsertIntoPriorityQueueBTNumKeyValue(q, 4, 3);
  InsertIntoPriorityQueueBTNumKeyValue(q, 3, 4);
  InsertIntoPriorityQueueBTNumKeyValue(q, 8, 5);

  size = SizeOfPriorityQueueBTNumKeyValue(q);

  AssertEquals(size, 5, failures);

  found = PopPriorityQueueBTNumKeyValue(q, keyReference, valueReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 11, failures);
  AssertEquals(valueReference.numberValue, 2, failures);
  found = PopPriorityQueueBTNumKeyValue(q, keyReference, valueReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 8, failures);
  AssertEquals(valueReference.numberValue, 5, failures);
  found = PopPriorityQueueBTNumKeyValue(q, keyReference, valueReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 5, failures);
  AssertEquals(valueReference.numberValue, 1, failures);
  found = PopPriorityQueueBTNumKeyValue(q, keyReference, valueReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 4, failures);
  AssertEquals(valueReference.numberValue, 3, failures);
  found = PopPriorityQueueBTNumKeyValue(q, keyReference, valueReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 3, failures);
  AssertEquals(valueReference.numberValue, 4, failures);
  found = PopPriorityQueueBTNumKeyValue(q, keyReference, valueReference);
  AssertFalse(found, failures);
}
function testPriorityQueueBTNumbers(failures){
  var q;
  var size;
  var keyReference, valueReference;
  var found;

  keyReference = {};

  q = CreatePriorityQueueBTNumbers();

  InsertIntoPriorityQueueBTNumbers(q, 5);
  InsertIntoPriorityQueueBTNumbers(q, 11);
  InsertIntoPriorityQueueBTNumbers(q, 4);
  InsertIntoPriorityQueueBTNumbers(q, 3);
  InsertIntoPriorityQueueBTNumbers(q, 8);

  size = SizeOfPriorityQueueBTNumbers(q);

  AssertEquals(size, 5, failures);

  found = PopPriorityQueueBTNumbers(q, keyReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 11, failures);
  found = PopPriorityQueueBTNumbers(q, keyReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 8, failures);
  found = PopPriorityQueueBTNumbers(q, keyReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 5, failures);
  found = PopPriorityQueueBTNumbers(q, keyReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 4, failures);
  found = PopPriorityQueueBTNumbers(q, keyReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 3, failures);
  found = PopPriorityQueueBTNumbers(q, keyReference);
  AssertFalse(found, failures);
}
function testPriorityQueueBTNumbers2(failures){
  var q;
  var size;
  var keyReference, valueReference;
  var found;

  keyReference = {};

  q = CreatePriorityQueueBTNumbers();

  InsertIntoPriorityQueueBTNumbers(q, 1.0);
  InsertIntoPriorityQueueBTNumbers(q, 0.5);
  InsertIntoPriorityQueueBTNumbers(q, 0.5);
  InsertIntoPriorityQueueBTNumbers(q, 0.3333333333333333);
  InsertIntoPriorityQueueBTNumbers(q, 0.3333333333333333);
  InsertIntoPriorityQueueBTNumbers(q, 0.25);
  InsertIntoPriorityQueueBTNumbers(q, 0.25);

  size = SizeOfPriorityQueueBTNumbers(q);

  AssertEquals(size, 7, failures);

  found = PopPriorityQueueBTNumbers(q, keyReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 1.0, failures);
  found = PopPriorityQueueBTNumbers(q, keyReference);
  AssertTrue(found, failures);
  AssertEquals(keyReference.numberValue, 0.5, failures);
}
function AddNumber(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddNumberRef(list, i){
  list.numberArray = AddNumber(list.numberArray, i);
}
function RemoveNumber(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetNumberRef(list, i){
  return list.numberArray[i];
}
function RemoveNumberRef(list, i){
  list.numberArray = RemoveNumber(list.numberArray, i);
}
function AddString(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;

  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddStringRef(list, i){
  list.stringArray = AddString(list.stringArray, i);
}
function RemoveString(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetStringRef(list, i){
  return list.stringArray[i];
}
function RemoveStringRef(list, i){
  list.stringArray = RemoveString(list.stringArray, i);
}
function AddBoolean(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddBooleanRef(list, i){
  list.booleanArray = AddBoolean(list.booleanArray, i);
}
function RemoveBoolean(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetBooleanRef(list, i){
  return list.booleanArray[i];
}
function RemoveDecimalRef(list, i){
  list.booleanArray = RemoveBoolean(list.booleanArray, i);
}
function CreateLinkedListString(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddString(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListStringsToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListStringsLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = {};
    array[i].string = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListStringsLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListString(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function CreateLinkedListNumbers(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function CreateLinkedListNumbersArray(lengthx){
  var lls;
  var i;

  lls = [];
  lls.length = lengthx;
  for(i = 0; i < lls.length; i = i + 1){
    lls[i] = CreateLinkedListNumbers();
  }

  return lls;
}
function LinkedListAddNumber(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListNumbersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function LinkedListNumbersIndex(ll, index){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  return node.value;
}
function LinkedListInsertNumber(ll, index, value){
  var i;
  var node, tmp;

  if(index == 0){
    tmp = ll.first;
    ll.first = {};
    ll.first.next = tmp;
    ll.first.value = value;
    ll.first.end = false;
  }else{
    node = ll.first;
    for(i = 0; i < index - 1; i = i + 1){
      node = node.next;
    }

    tmp = node.next;
    node.next = {};
    node.next.next = tmp;
    node.next.value = value;
    node.next.end = false;
  }
}
function LinkedListSet(ll, index, value){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  node.next.value = value;
}
function LinkedListRemoveNumber(ll, index){
  var i;
  var node, prev;

  node = ll.first;
  prev = ll.first;

  for(i = 0; i < index; i = i + 1){
    prev = node;
    node = node.next;
  }

  if(index == 0){
    ll.first = prev.next;
  }
  if( !prev.next.end ){
    prev.next = prev.next.next;
  }
}
function FreeLinkedListNumbers(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function FreeLinkedListNumbersArray(lls){
  var i;

  for(i = 0; i < lls.length; i = i + 1){
    FreeLinkedListNumbers(lls[i]);
  }
  delete(lls);
}
function LinkedListNumbersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListNumbersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function ArrayToLinkedListNumbers(array){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < array.length; i = i + 1){
    LinkedListAddNumber(ll, array[i]);
  }

  return ll;
}
function LinkedListNumbersEqual(a, b){
  var equal, done;
  var an, bn;

  an = a.first;
  bn = b.first;

  equal = true;
  done = false;
  for(; equal &&  !done ; ){
    if(an.end == bn.end){
      if(an.end){
        done = true;
      }else if(an.value == bn.value){
        an = an.next;
        bn = bn.next;
      }else{
        equal = false;
      }
    }else{
      equal = false;
    }
  }

  return equal;
}
function CreateLinkedListCharacter(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddCharacter(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListCharactersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListCharactersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListCharactersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListCharacter(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function CreateDynamicArrayNumbers(){
  var da;

  da = {};
  da.array = [];
  da.array.length = 10;
  da.lengthx = 0;

  return da;
}
function CreateDynamicArrayNumbersWithInitialCapacity(capacity){
  var da;

  da = {};
  da.array = [];
  da.array.length = capacity;
  da.lengthx = 0;

  return da;
}
function DynamicArrayAddNumber(da, value){
  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  da.array[da.lengthx] = value;
  da.lengthx = da.lengthx + 1;
}
function DynamicArrayNumbersIncreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*3/2);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < da.array.length; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersDecreaseSizeNecessary(da){
  var needsDecrease;

  needsDecrease = false;

  if(da.lengthx > 10){
    needsDecrease = da.lengthx <= Math.round(da.array.length*2/3);
  }

  return needsDecrease;
}
function DynamicArrayNumbersDecreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*2/3);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < newLength; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersIndex(da, index){
  return da.array[index];
}
function DynamicArrayNumbersLength(da){
  return da.lengthx;
}
function DynamicArrayInsertNumber(da, index, value){
  var i;

  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  for(i = da.lengthx; i > index; i = i - 1){
    da.array[i] = da.array[i - 1];
  }

  da.array[index] = value;

  da.lengthx = da.lengthx + 1;
}
function DynamicArraySet(da, index, value){
  da.array[index] = value;
}
function DynamicArrayRemoveNumber(da, index){
  var i;

  for(i = index; i < da.lengthx - 1; i = i + 1){
    da.array[i] = da.array[i + 1];
  }

  da.lengthx = da.lengthx - 1;

  if(DynamicArrayNumbersDecreaseSizeNecessary(da)){
    DynamicArrayNumbersDecreaseSize(da);
  }
}
function FreeDynamicArrayNumbers(da){
  delete(da.array);
  delete(da);
}
function DynamicArrayNumbersToArray(da){
  var array;
  var i;

  array = [];
  array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    array[i] = da.array[i];
  }

  return array;
}
function ArrayToDynamicArrayNumbersWithOptimalSize(array){
  var da;
  var i;
  var c, n, newCapacity;

  /*
         c = 10*(3/2)^n
         log(c) = log(10*(3/2)^n)
         log(c) = log(10) + log((3/2)^n)
         log(c) = 1 + log((3/2)^n)
         log(c) - 1 = log((3/2)^n)
         log(c) - 1 = n*log(3/2)
         n = (log(c) - 1)/log(3/2)
         */
  c = array.length;
  n = (Math.log(c) - 1)/Math.log(3/2);
  newCapacity = Math.floor(n) + 1;

  da = CreateDynamicArrayNumbersWithInitialCapacity(newCapacity);

  for(i = 0; i < array.length; i = i + 1){
    da.array[i] = array[i];
  }

  return da;
}
function ArrayToDynamicArrayNumbers(array){
  var da;

  da = {};
  da.array = CopyNumberArray(array);
  da.lengthx = array.length;

  return da;
}
function DynamicArrayNumbersEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.lengthx == b.lengthx){
    for(i = 0; i < a.lengthx && equal; i = i + 1){
      if(a.array[i] != b.array[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function DynamicArrayNumbersToLinkedList(da){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < da.lengthx; i = i + 1){
    LinkedListAddNumber(ll, da.array[i]);
  }

  return ll;
}
function LinkedListToDynamicArrayNumbers(ll){
  var da;
  var i;
  var node;

  node = ll.first;

  da = {};
  da.lengthx = LinkedListNumbersLength(ll);

  da.array = [];
  da.array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    da.array[i] = node.value;
    node = node.next;
  }

  return da;
}
function AddCharacter(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddCharacterRef(list, i){
  list.string = AddCharacter(list.string, i);
}
function RemoveCharacter(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }

  return newlist;
}
function GetCharacterRef(list, i){
  return list.string[i];
}
function RemoveCharacterRef(list, i){
  list.string = RemoveCharacter(list.string, i);
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function StringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function SwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function ReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    SwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !StringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}


module.exports = {
	CreatePriorityQueueBTNumbers: CreatePriorityQueueBTNumbers,
	FreePriorityQueueBTNumbers: FreePriorityQueueBTNumbers,
	PeekPriorityQueueBTNumbers: PeekPriorityQueueBTNumbers,
	InsertIntoPriorityQueueBTNumbers: InsertIntoPriorityQueueBTNumbers,
	PopPriorityQueueBTNumbers: PopPriorityQueueBTNumbers,
	DeleteTopPriorityQueueBTNumbers: DeleteTopPriorityQueueBTNumbers,
	ArrayToPriorityQueueBTNumbers: ArrayToPriorityQueueBTNumbers,
	SizeOfPriorityQueueBTNumbers: SizeOfPriorityQueueBTNumbers,
	IsEmptyPriorityQueueBTNumbers: IsEmptyPriorityQueueBTNumbers,
	SiftUpPriorityQueueBTNumbers: SiftUpPriorityQueueBTNumbers,
	SiftDownPriorityQueueBTNumbers: SiftDownPriorityQueueBTNumbers,
	CreatePriorityQueueBTNumKeyValue: CreatePriorityQueueBTNumKeyValue,
	FreePriorityQueueBTNumKeyValue: FreePriorityQueueBTNumKeyValue,
	PeekPriorityQueueBTNumKeyValue: PeekPriorityQueueBTNumKeyValue,
	InsertIntoPriorityQueueBTNumKeyValue: InsertIntoPriorityQueueBTNumKeyValue,
	PopPriorityQueueBTNumKeyValue: PopPriorityQueueBTNumKeyValue,
	DeleteTopPriorityQueueBTNumKeyValue: DeleteTopPriorityQueueBTNumKeyValue,
	ArrayToPriorityQueueBTNumKeyValue: ArrayToPriorityQueueBTNumKeyValue,
	SizeOfPriorityQueueBTNumKeyValue: SizeOfPriorityQueueBTNumKeyValue,
	IsEmptyPriorityQueueBTNumKeyValue: IsEmptyPriorityQueueBTNumKeyValue,
	SiftUpPriorityQueueBTNumKeyValue: SiftUpPriorityQueueBTNumKeyValue,
	SiftDownPriorityQueueBTNumKeyValue: SiftDownPriorityQueueBTNumKeyValue,
	AddNumber: AddNumber,
	AddNumberRef: AddNumberRef,
	RemoveNumber: RemoveNumber,
	GetNumberRef: GetNumberRef,
	RemoveNumberRef: RemoveNumberRef,
	AddString: AddString,
	AddStringRef: AddStringRef,
	RemoveString: RemoveString,
	GetStringRef: GetStringRef,
	RemoveStringRef: RemoveStringRef,
	AddBoolean: AddBoolean,
	AddBooleanRef: AddBooleanRef,
	RemoveBoolean: RemoveBoolean,
	GetBooleanRef: GetBooleanRef,
	RemoveDecimalRef: RemoveDecimalRef,
	CreateLinkedListString: CreateLinkedListString,
	LinkedListAddString: LinkedListAddString,
	LinkedListStringsToArray: LinkedListStringsToArray,
	LinkedListStringsLength: LinkedListStringsLength,
	FreeLinkedListString: FreeLinkedListString,
	CreateLinkedListNumbers: CreateLinkedListNumbers,
	CreateLinkedListNumbersArray: CreateLinkedListNumbersArray,
	LinkedListAddNumber: LinkedListAddNumber,
	LinkedListNumbersLength: LinkedListNumbersLength,
	LinkedListNumbersIndex: LinkedListNumbersIndex,
	LinkedListInsertNumber: LinkedListInsertNumber,
	LinkedListSet: LinkedListSet,
	LinkedListRemoveNumber: LinkedListRemoveNumber,
	FreeLinkedListNumbers: FreeLinkedListNumbers,
	FreeLinkedListNumbersArray: FreeLinkedListNumbersArray,
	LinkedListNumbersToArray: LinkedListNumbersToArray,
	ArrayToLinkedListNumbers: ArrayToLinkedListNumbers,
	LinkedListNumbersEqual: LinkedListNumbersEqual,
	CreateLinkedListCharacter: CreateLinkedListCharacter,
	LinkedListAddCharacter: LinkedListAddCharacter,
	LinkedListCharactersToArray: LinkedListCharactersToArray,
	LinkedListCharactersLength: LinkedListCharactersLength,
	FreeLinkedListCharacter: FreeLinkedListCharacter,
	CreateDynamicArrayNumbers: CreateDynamicArrayNumbers,
	CreateDynamicArrayNumbersWithInitialCapacity: CreateDynamicArrayNumbersWithInitialCapacity,
	DynamicArrayAddNumber: DynamicArrayAddNumber,
	DynamicArrayNumbersIncreaseSize: DynamicArrayNumbersIncreaseSize,
	DynamicArrayNumbersDecreaseSizeNecessary: DynamicArrayNumbersDecreaseSizeNecessary,
	DynamicArrayNumbersDecreaseSize: DynamicArrayNumbersDecreaseSize,
	DynamicArrayNumbersIndex: DynamicArrayNumbersIndex,
	DynamicArrayNumbersLength: DynamicArrayNumbersLength,
	DynamicArrayInsertNumber: DynamicArrayInsertNumber,
	DynamicArraySet: DynamicArraySet,
	DynamicArrayRemoveNumber: DynamicArrayRemoveNumber,
	FreeDynamicArrayNumbers: FreeDynamicArrayNumbers,
	DynamicArrayNumbersToArray: DynamicArrayNumbersToArray,
	ArrayToDynamicArrayNumbersWithOptimalSize: ArrayToDynamicArrayNumbersWithOptimalSize,
	ArrayToDynamicArrayNumbers: ArrayToDynamicArrayNumbers,
	DynamicArrayNumbersEqual: DynamicArrayNumbersEqual,
	DynamicArrayNumbersToLinkedList: DynamicArrayNumbersToLinkedList,
	LinkedListToDynamicArrayNumbers: LinkedListToDynamicArrayNumbers,
	AddCharacter: AddCharacter,
	AddCharacterRef: AddCharacterRef,
	RemoveCharacter: RemoveCharacter,
	GetCharacterRef: GetCharacterRef,
	RemoveCharacterRef: RemoveCharacterRef,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayRange: FillNumberArrayRange,
	FillBooleanArrayRange: FillBooleanArrayRange,
	FillStringRange: FillStringRange,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SwapElementsOfNumberArray: SwapElementsOfNumberArray,
	SwapElementsOfStringArray: SwapElementsOfStringArray,
	ReverseNumberArray: ReverseNumberArray,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	test: test
};